/**
 * Comparison call back compares two values and returns a number representing priority from highest to lowest
 * @returns number 1, 0, -1
 */
export declare type CompareTo<T> = (a: T, b: T) => number;
export declare class PriorityQueue<T> {
    private parentIndex;
    private leftIndex;
    private rightIndex;
    private heap;
    compare: CompareTo<T>;
    constructor(compareCbk: CompareTo<T>);
    get peek(): T;
    get length(): number;
    enqueue(obj: T): void;
    dequeue(): T | undefined;
    clear(): void;
}
